function cont(X,I,s,nsh,typ);
% vypocet parametru funkce contour
%
% vstupni parametry:
% X - matice vektoru
% I - matice priznaku
% s - parametr pro polynomialni funkci - rad polynomu nebo pro RBF parametr sigma
%     (vyber podle parametru typ)
% nsh - pocet shluku
% typ - vyber jadrove funkce:
%                 'lin' - linearni funkce
%                 'poly' - polynomialni funkce
%                 'rbf' - RBF funkce 

presnost=50;
l=min(X(1,:));
p=max(X(1,:));
t=max(X(2,:));
b=min(X(2,:));

n=size(X,2);

  D=zeros(n,nsh);	%D(i) - vzdalenost testovaneho bodu od shluku i   
   XT=zeros(n,nsh);      
   TT=zeros(1,nsh);   
   XX=zeros(1,n);   
   for sh=1:nsh
       Pa=(I==sh);   
       pocet(sh)=Pa*Pa';	%pocet(i) - pocet bodu ve shluku i        
       for p=1:n
       	 if I(p)==sh
            for q=1:n
                if I(q)==sh         
                   TT(sh)=TT(sh)+k(X(:,p),X(:,q),s,typ);
                end
             end
          end
       end
       TT(sh)=TT(sh)/pocet(sh)^2;
    end      
    for i=1:n
      XX(i)=XX(i)+k(X(:,i),X(:,i),s,typ);
    end
    for i=1:n
      for sh=1:nsh
         for p=1:n
            if I(p)==sh
                  XT(i,sh)=XT(i,sh)+k(X(:,i),X(:,p),s,typ);
            end            
         end
         D(i,sh)=XX(i)-2*XT(i,sh)/pocet(sh)+TT(sh);                  
      end
   end
   Dmax=zeros(1,nsh)
   for i=1:n
      for sh=1:nsh
         if (I(i)==sh)
            if Dmax(sh)<D(i,sh)
               Dmax(sh)=D(i,sh);
            end
         end
      end
   end
   
l=min(X(1,:));
p=max(X(1,:));
t=max(X(2,:));
b=min(X(2,:));
tmp=(p-l)*0.2;
l=l-tmp;p=p+tmp;
tmp=(t-b)*0.2;
b=b-tmp;t=t+tmp;

   
   x=[l:(p-l)/presnost:p];
   y=[b:(t-b)/presnost:t];
sss=size(x,2)*size(y,2)
w=zeros(2,sss);
a1=l;
for i=1:size(x,2)
   a2=b;
   for j=1:size(y,2)
      w(1,(i-1)*size(x,2)+j)=a1;
      w(2,(i-1)*size(y,2)+j)=a2;
      a2=a2+(t-b)/presnost;
   end   
   a1=a1+(p-l)/presnost;
end

  D=zeros(nsh,sss);	%D(i) - vzdalenost testovaneho bodu od shluku i   
   XT=zeros(nsh,sss);      
   TT=zeros(1,nsh);   
   XX=zeros(1,sss);   
   for sh=1:nsh
       Pa=(I==sh);   
       pocet(sh)=Pa*Pa';	%pocet(i) - pocet bodu ve shluku i        
       for p=1:n
       	 if I(p)==sh
            for q=1:n
                if I(q)==sh         
                   TT(sh)=TT(sh)+k(X(:,p),X(:,q),s,typ);
                end
             end
          end
       end
       TT(sh)=TT(sh)/pocet(sh)^2;
    end      
    for i=1:sss
      XX(i)=XX(i)+k(w(:,i),w(:,i),s,typ);
   end
      
   Z=100*ones(size(x,2),size(y,2));
   
   for ii=1:size(x,2)
   for j=1:size(y,2)
		i=(ii-1)*size(x,2)+j;				         
      for sh=1:nsh
         for p=1:n
            if I(p)==sh
               	XT(sh,i)=XT(sh,i)+k(w(:,i),X(:,p),s,typ);
            end            
         end
         D(sh,i)=XX(i)-2*XT(sh,i)/pocet(sh)+TT(sh);
         if (D(sh,i))<Dmax(sh)
            Z(j,ii)=sh;%D(sh,i);
         end         
      end
   end
   end  
   contour(x,y,Z,1);
